var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentField, VegaSlimmer } from 'vega-slimmer/core';
/**
 * Parse the code content to different tokens.
 */
export class CodeContentParseController extends VegaSlimmer {
  constructor() {
    super(...arguments);
    this.codeNodes = [];
  }
  /**
   * Get the current rendering code node array.
   *
   * @returns {CodeNodeType[]} - The code node array.
   */
  getCurrentCodeNodes() {
    return this.codeNodes;
  }
  /**
   * Split the code content to code node array. The default parse used if the language is not defined.
   *
   * @returns {CodeNodeType[]} - The code node array.
   */
  parseCode() {
    const parsers = [
      this.prismCodeHighlightParser,
      this.defaultCodeHighlightParser,
    ];
    let result = [];
    for (const parser of parsers) {
      if (parser.canParse()) {
        result = parser.parse();
        break;
      }
    }
    this.codeNodes = result;
    return result;
  }
}
__decorate([
  MapToComponentField()
], CodeContentParseController.prototype, "prismCodeHighlightParser", void 0);
__decorate([
  MapToComponentField()
], CodeContentParseController.prototype, "defaultCodeHighlightParser", void 0);
